#!/usr/bin/perl
# Скипт для периодической чистки db-базы от устаревших записей.

use BerkeleyDB;
use Socket;

require "/etc/spam_check/clean_dn.conf";

# Текущее время и текущий день.
my $now_time = time();


    # Подключаем хэш базу с результатами старых проверок.
    my %chk_cache;
    tie (%chk_cache, 'BerkeleyDB::Btree',
	-Filename   => $cfg_checker_cache_file,
	-Flags      => DB_CREATE,
	-Cachesize   => DB_CACHE_SIZE) or die "ERROR:Cannot create/open $cfg_checker_cache_file: $!";

    # Перебираем записи в базе.
    foreach my $cur_num_ip (keys %chk_cache){
	my $cur_ip = inet_ntoa($cur_num_ip);
        my ($cur_time, $cur_con, $cur_weight) = split(/\:/, $chk_cache{$cur_num_ip});

        my ($sec,$min,$hour,$mday,$mon,$year) = localtime($cur_time);
	my $str_time = sprintf("%2.2d %2.2d %d %2.2d:%2.2d:%2.2d",$mday, $mon+1, 1900+$year, $hour, $min, $sec);

	if ($cur_weight >= $cfg_block_weight){
    	    if ($cur_time + $cfg_nospam_timetolive < $now_time){
		delete $chk_cache{$cur_num_ip};
		if ($cfg_verbose_level > 0){
		    print "DEL SPAM:$cur_ip:$cur_con:$cur_weight:$str_time\n";
		}
	    } elsif ($cfg_verbose_level > 1){
		print "SKIP SPAM:$cur_ip:$cur_con:$cur_weight:$str_time\n";
	    }
	} elsif ($cfg_verbose_level > 1){
	    print "SKIP OK:$cur_ip:$cur_con:$cur_weight:$str_time\n";
	}
    }

    untie %chk_cache;
